#!/usr/bin/perl

use strict;

my $Version = "DoAllFrogs.pl 1.03 2022-04-15";

print "$Version\n\n";

my $chmodmask = "744";	# (Linux only) mask used to chmod the 'Gemall.sh' output script.
$chmodmask = "+x";

my @arg;
my $Cnt = 0;
my $arg = shift;

my $Operation = "frog";		# frog == MarkdownWrapper.pl  fixcr == changes CR/LFs to LF.
# The fixcr operation only works once!  So am disabling it.
#if ($arg =~ m/fixcr/i) { $Operation = "fixcr" }

while ($arg) {
	#print "\$arg$Cnt: $arg\n";
	push (@arg, $arg);
	$arg = shift;
	$Cnt++;
}

print "\n";

my $ShoutOut = "";
my $DirMask;
if ( $Operation =~ m/frog/i ) {
	$DirMask = '(\.md$)|(\.mdf$)';
	$ShoutOut = "Running MarkdownWrapper.pl";
} elsif ( $Operation =~ m/fixcr/i ) {
	$DirMask = '\.pl$';
	$DirMask = "(\.pl\$)|(\.sh\$)";
	$ShoutOut = "Changing CR/LFs to LFs";
} else {
	print "Invalid \$Operation: $Operation\n"; exit -1;
}

# print "\$DirMask: '$DirMask'\n";

my $pwd = `pwd`;
chomp $pwd;
$pwd =~ s|\\|/|g;
my $Script = "";
my $ScriptName = "";
my $Prefix = "";
my $PPrefix = "";

my $Comment = "";
if ( $^O =~ /MSWin.*/i ) {
	print "Windows pwd: $pwd\n";
	$Comment = "Rem";
	$Script .= "echo off\n";
	$Script .= "$Comment Windows batch file to run MarkdownWrapper.pl\n";
	$Script .= "$Comment (Perl says that we are '$^O'\n";
	$Script .= "$Comment Generated by $Version\n";
	$Script .= "$Comment $ShoutOut\n";
	$Script .= "\n";
	$ScriptName = "GenAll.bat";
	$Prefix = "$pwd" . "/";	# MarkdownWrapper.pl needs fully qualified filenames.
	$PPrefix = "call ";
	$Prefix = "";
	$PPrefix = "";	
} else {
	print "Linux pwd: $pwd\n";
	$Comment = "#";
	$Script .= "#!/bin/bash\n";
	$Script .= "#\n";	
	$Script .= "# Generated by $Version\n";
	$Script .= "# (Perl says that we are '$^O'\n";
	$Script .= "# $ShoutOut\n";
	$Script .= "\n";
	#$Script .= "Cnt=0";
	$ScriptName = "GenAll.sh";
}

my (@files);
opendir (DIR, $pwd) || die ("can't open $pwd\n");
foreach ( readdir(DIR) ) {	# Loop through all the files in the directory.
	if ( m/^_/) {
		print "(Excluding '$_' because it starts with a leading '_'.)\n";
		next;	# Files with leading '_'s are for debugging from the command prompt.
	} elsif ( m/$DirMask/i ) {
		push (@files, $_);
	}
}
closedir (DIR) || die ("can't close $pwd\n");

print "\n";
@files = sort( {lc $a cmp lc $b} @files);	
my ($JustFile, $ConfigFile, $Command);
my $q = '"';

foreach $JustFile (@files) {
	foreach $ConfigFile (@arg) {
		if ( $Operation =~ m/frog/i ) {
			$Command = $PPrefix . "MarkdownWrapper.pl $q$Prefix$JustFile$q $q$ConfigFile$q";
		} elsif ( $Operation =~ m/fixcr/i ) {
			my $p = '';
			$Command = "perl -pi~ -e 's%\\015%%g' $q$Prefix$JustFile$q";
		} else {
			print "Should not happen.\n";
			exit -1;
		}
		unless ( $^O =~ /MSWin.*/i ) {
			#$Script .= "\$Cnt++\n";
		}
		#print "  $Command\n";
		$Script .= $Command . "\n";
	}
}

if ( $^O =~ /MSWin.*/i ) {
	$Script .= "pause\n";	# Pause after running.  For double clicking.
} else {
	#$Script .= "echo It took \$SECONDS to process \$Cnt files\n";
	$Script .= "echo It took \$SECONDS seconds.\n";

}

print "$Script";

open (OUT, ">$ScriptName") || die "Cannot open '$ScriptName'";
print OUT $Script;
close OUT;

print "\nWrote script: $ScriptName\n";
unless ( $^O =~ /MSWin.*/i ) { 
	print "chmod $chmodmask $ScriptName\n";
	`chmod $chmodmask $ScriptName`;
}
print "Examine it, edit it (if needed) and maybe run it.\n";

exit 0;
